import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import '../json_forms.dart';
import 'SectionWidget.dart';
import 'Classes.dart' as classes;

class FormProvider extends ChangeNotifier {
  classes.Form _form;
  List<SectionController> _sections = List();
  Map<JsonFormController, List<JsonFormController>>
      _questions = Map();
  Map<JsonFormController, classes.QuestionController> _controllers =
      Map();

  classes.Form get form => _form;
  List<JsonFormController> get sectionControllers => _sections;
  Map<JsonFormController, List<JsonFormController>>
      get questionControllers => _questions;
  Map<JsonFormController, classes.QuestionController>
      get controllers => _controllers;

  void init(Map<String, dynamic> json, bool readOnly) {
    setForm(json, readOnly);
  }

  void setForm(Map<String, dynamic> json, bool readOnly) {
    _form = classes.Form.fromJson(json);

    _sections = List();
    _questions = Map();
    _controllers = Map();

    for (var i = 0; i < _form.sections.length; i++) {
      final sController = SectionController();
      _sections.add(sController);
      _questions.putIfAbsent(sController, () => List<JsonFormController>());
      for (var j = 0; j < _form.sections[i].questions.length; j++) {
        final qController = JsonFormController();
        _questions[sController].add(qController);
        classes.QuestionController qcontroller = classes.QuestionController(
            sectionController: sController,
            question: _form.sections[i].questions[j],
            readOnly: readOnly);
        _controllers.putIfAbsent(qController, () => qcontroller);
      }
    }
  }
}
