/*
 * File Created: 22nd October 2019 7:11:26 am
 * Author: Alban LECUIVRE
 * -----
 * Copyright - 2019 Alban LECUIVRE
 */

import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:json_forms/json_forms.dart';


void main() {
  testWidgets('JsonForm', (WidgetTester tester) async {
    Map<String,dynamic> json;
    print('DEBUG : Reading JSON file...');
    await rootBundle.loadString('test/nadjibi.json')
    .then((fileString) => jsonDecode(fileString))
    .then((fileJson){
      json = fileJson;
    });
    print('DEBUG : Read JSON file DONE');
    print('DEBUG : Starting JsonForm Widget creation...');
    await tester.pumpWidget(
      MaterialApp(
        home: Scaffold(
          body: JsonForm.fromJson(
            json,
            hideBar: true,
            controller: JsonFormController()
          ),
        )
      )
    );
    print('DEBUG : Starting JsonForm Widget creation DONE');
  });
}
